## libtgowt 0~git20211207.d5c3d43+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
cmake_policy(SET CMP0076 NEW)
cmake_policy(SET CMP0091 NEW)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(TG_OWT_SPECIAL_TARGET "" CACHE STRING "Use special platform target, like 'macstore' for Mac App Store.")

set(CMAKE_OSX_DEPLOYMENT_TARGET 10.11 CACHE STRING "Minimum OS X deployment version" FORCE)

if (NOT TG_OWT_SPECIAL_TARGET STREQUAL "")
    set(TG_OWT_PACKAGED_BUILD 0)
else()
    set(TG_OWT_PACKAGED_BUILD 1)
endif()

set(not_packaged_build 0)
if (NOT TG_OWT_PACKAGED_BUILD)
    set(not_packaged_build 1)
endif()

option(BUILD_SHARED_LIBS "Builds shared libraries instead of static." ${TG_OWT_PACKAGED_BUILD})
option(TG_OWT_USE_PROTOBUF "Use protobuf to generate additional headers. Useful for packaged build." ${BUILD_SHARED_LIBS})
option(TG_OWT_USE_PIPEWIRE "Use pipewire for desktop capture on non-Apple Unix." ON)
option(TG_OWT_DLOPEN_PIPEWIRE "dlopen pipewire 0.3 for desktop capture on non-Apple Unix." ${not_packaged_build})
option(TG_OWT_BUILD_AUDIO_BACKENDS "Build webrtc audio backends." ON)

if (NOT UNIX OR APPLE)
    set(TG_OWT_USE_PIPEWIRE OFF)
endif()

if (BUILD_SHARED_LIBS)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

project(tg_owt
    LANGUAGES C CXX ASM
    DESCRIPTION "WebRTC build for Telegram"
    HOMEPAGE_URL "https://github.com/desktop-app/tg_owt.git"
)
set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT tg_owt)

get_filename_component(webrtc_loc "src" REALPATH)
set(third_party_loc ${webrtc_loc}/third_party)
set(tools_loc ${webrtc_loc}/tools)

include(GNUInstallDirs)
set(webrtc_includedir ${CMAKE_INSTALL_INCLUDEDIR}/tg_owt)

if (CMAKE_OSX_ARCHITECTURES STREQUAL "arm64")
    set(is_aarch64 1)
    set(arm_use_neon 1)
else()
    if(CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")
        set(is_x64 1)
    else()
        include(cmake/arch.cmake)
    endif()
endif()

include(cmake/nice_target_sources.cmake)
include(cmake/init_target.cmake)
include(cmake/generate_target.cmake)
include(cmake/target_yasm_sources.cmake)
include(cmake/external.cmake)
include(cmake/libabsl.cmake)
include(cmake/libopenh264.cmake)
include(cmake/libpffft.cmake)
include(cmake/librnnoise.cmake)
include(cmake/libsrtp.cmake)
include(cmake/libusrsctp.cmake)
include(cmake/libvpx.cmake)
include(cmake/libyuv.cmake)
if (APPLE)
    include(cmake/libsdkmacos.cmake)
endif()

# Use a separate subdirectory, because it will be exported as an INTERFACE
# for the generated sources and headers.
if (TG_OWT_USE_PROTOBUF)
    add_subdirectory(cmake/protobuf)
endif()

add_library(tg_owt)
init_target(tg_owt)

if (TG_OWT_USE_PIPEWIRE)
    if (TG_OWT_DLOPEN_PIPEWIRE)
        include(cmake/generate_stubs.cmake)
        set(stubs_loc ${webrtc_loc}/modules/desktop_capture/linux)
        generate_stubs(tg_owt
            ${stubs_loc}/pipewire_stub_header.fragment
            pipewire_stubs
            ${stubs_loc}/pipewire03.sigs
        )
        target_compile_definitions(tg_owt
        PRIVATE
            WEBRTC_DLOPEN_PIPEWIRE
        )
        target_include_directories(tg_owt
        PRIVATE
            ${webrtc_loc}/third_party/pipewire/spa/include
            ${webrtc_loc}/third_party/pipewire/src
            ${webrtc_loc}/third_party/pipewire/build/src
        )
    else()
        link_pipewire(tg_owt)
    endif()
endif()

set_target_properties(tg_owt PROPERTIES SOVERSION 0 VERSION 0.0.0)

target_link_libraries(tg_owt
PRIVATE
    tg_owt::libpffft
    tg_owt::librnnoise
    tg_owt::libsrtp
    tg_owt::libyuv
)

if (is_x86 OR is_x64)
    target_link_libraries(tg_owt
    PRIVATE
        tg_owt::tg_owt_avx2
        tg_owt::tg_owt_sse2
    )
endif()

if (TG_OWT_USE_PROTOBUF)
    target_link_libraries(tg_owt
    PRIVATE
        tg_owt::proto
    )
endif()

target_sources(tg_owt
PRIVATE
    ${libvpx_yasm_objects}
    ${libopenh264_yasm_objects}
)

if (APPLE)
    target_link_libraries(tg_owt PUBLIC tg_owt::libsdkmacos)
endif()

link_openssl(tg_owt)
link_ffmpeg(tg_owt)
link_opus(tg_owt)
link_libabsl(tg_owt)
link_libopenh264(tg_owt)
link_libusrsctp(tg_owt)
link_libvpx(tg_owt)

if (TG_OWT_BUILD_AUDIO_BACKENDS AND (UNIX AND NOT APPLE))
    link_libalsa(tg_owt)
    link_libpulse(tg_owt)
    link_dl(tg_owt)
endif()

include(cmake/libwebrtcbuild.cmake)
target_link_libraries(tg_owt PUBLIC tg_owt::libwebrtcbuild)

if (UNIX AND NOT APPLE)
    link_x11(tg_owt)
    link_glib(tg_owt)
endif()

function(add_sublibrary postfix)
    add_library(tg_owt_${postfix} OBJECT)
    init_feature_target(tg_owt_${postfix} ${postfix})
    add_library(tg_owt::tg_owt_${postfix} ALIAS tg_owt_${postfix})
    target_link_libraries(tg_owt_${postfix}
    PUBLIC
        tg_owt::libwebrtcbuild
    )
    link_libabsl(tg_owt_${postfix})
    target_include_directories(tg_owt_${postfix}
    PUBLIC
        $<BUILD_INTERFACE:${webrtc_loc}>
        $<INSTALL_INTERFACE:${webrtc_includedir}>
    )
    set(sources_list ${ARGV})
    list(REMOVE_AT sources_list 0)
    nice_target_sources(tg_owt_${postfix} ${webrtc_loc}
    PRIVATE
        ${sources_list}
    )
endfunction()

nice_target_sources(tg_owt ${webrtc_loc}
PRIVATE
    rtc_base/deprecated/recursive_critical_section.cc
    rtc_base/deprecated/recursive_critical_section.h
    rtc_base/async_invoker.cc
    rtc_base/async_invoker.h
    rtc_base/async_invoker_inl.h
    rtc_base/async_packet_socket.cc
    rtc_base/async_packet_socket.h
    rtc_base/async_resolver_interface.cc
    rtc_base/async_resolver_interface.h
    rtc_base/async_resolver.cc
    rtc_base/async_resolver.h
    rtc_base/async_socket.cc
    rtc_base/async_socket.h
    rtc_base/async_tcp_socket.cc
    rtc_base/async_tcp_socket.h
    rtc_base/async_udp_socket.cc
    rtc_base/async_udp_socket.h
    rtc_base/callback_list.cc
    rtc_base/callback_list.h
    rtc_base/crc32.cc
    rtc_base/crc32.h
    rtc_base/crypt_string.cc
    rtc_base/crypt_string.h
    rtc_base/checks.cc
    rtc_base/checks.h
    # rtc_base/critical_section.cc
    # rtc_base/critical_section.h
    rtc_base/data_rate_limiter.cc
    rtc_base/data_rate_limiter.h
    rtc_base/dscp.h
    rtc_base/file_rotating_stream.cc
    rtc_base/file_rotating_stream.h
    rtc_base/helpers.cc
    rtc_base/helpers.h
    rtc_base/http_common.cc
    rtc_base/http_common.h
    rtc_base/ip_address.cc
    rtc_base/ip_address.h
    rtc_base/logging.cc
    rtc_base/logging.h
    # rtc_base/keep_ref_until_done.h
    rtc_base/mdns_responder_interface.h
    rtc_base/memory/aligned_malloc.cc
    rtc_base/memory/aligned_malloc.h
    rtc_base/memory/fifo_buffer.cc
    rtc_base/memory/fifo_buffer.h
    rtc_base/message_digest.cc
    rtc_base/message_digest.h
    rtc_base/message_handler.cc
    rtc_base/message_handler.h
    rtc_base/net_helper.cc
    rtc_base/net_helper.h
    rtc_base/net_helpers.cc
    rtc_base/net_helpers.h
    rtc_base/network/sent_packet.cc
    rtc_base/network/sent_packet.h
    rtc_base/network.cc
    rtc_base/network_route.cc
    rtc_base/network.h
    rtc_base/network_constants.cc
    rtc_base/network_constants.h
    rtc_base/network_monitor.cc
    rtc_base/network_monitor.h
    rtc_base/network_route.h
    rtc_base/null_socket_server.cc
    rtc_base/null_socket_server.h
    rtc_base/platform_thread.cc
    rtc_base/platform_thread.h
    rtc_base/platform_thread_types.cc
    rtc_base/platform_thread_types.h
    rtc_base/operations_chain.cc
    rtc_base/operations_chain.h
    rtc_base/openssl.h
    rtc_base/openssl_adapter.cc
    rtc_base/openssl_adapter.h
    rtc_base/openssl_certificate.cc
    rtc_base/openssl_certificate.h
    rtc_base/openssl_digest.cc
    rtc_base/openssl_digest.h
    rtc_base/openssl_identity.cc
    rtc_base/openssl_identity.h
    rtc_base/openssl_key_pair.cc
    rtc_base/openssl_key_pair.h
    rtc_base/openssl_session_cache.cc
    rtc_base/openssl_session_cache.h
    rtc_base/openssl_stream_adapter.cc
    rtc_base/openssl_stream_adapter.h
    rtc_base/openssl_utility.cc
    rtc_base/openssl_utility.h
    rtc_base/physical_socket_server.cc
    rtc_base/physical_socket_server.h
    rtc_base/proxy_info.cc
    rtc_base/proxy_info.h
    rtc_base/rtc_certificate.cc
    rtc_base/rtc_certificate.h
    rtc_base/rtc_certificate_generator.cc
    rtc_base/rtc_certificate_generator.h
    rtc_base/rate_limiter.cc
    rtc_base/rate_limiter.h
    # rtc_base/signal_thread.cc
    # rtc_base/signal_thread.h
    rtc_base/sigslot_repeater.h
    rtc_base/socket.cc
    rtc_base/socket.h
    rtc_base/socket_adapters.cc
    rtc_base/socket_adapters.h
    rtc_base/socket_address.cc
    rtc_base/socket_address.h
    rtc_base/socket_address_pair.cc
    rtc_base/socket_address_pair.h
    rtc_base/socket_factory.h
    rtc_base/socket_server.h
    rtc_base/ssl_adapter.cc
    rtc_base/ssl_adapter.h
    rtc_base/ssl_certificate.cc
    rtc_base/ssl_certificate.h
    rtc_base/ssl_fingerprint.cc
    rtc_base/ssl_fingerprint.h
    rtc_base/ssl_identity.cc
    rtc_base/ssl_identity.h
    rtc_base/ssl_stream_adapter.cc
    rtc_base/ssl_stream_adapter.h
    rtc_base/stream.cc
    rtc_base/stream.h
    rtc_base/time_utils.cc
    rtc_base/time_utils.h
    rtc_base/thread.cc
    rtc_base/thread.h
    rtc_base/thread_message.h
    rtc_base/unique_id_generator.cc
    rtc_base/unique_id_generator.h
    # rtc_base/bind.h
    rtc_base/bit_buffer.cc
    rtc_base/bit_buffer.h
    rtc_base/buffer.h
    rtc_base/buffer_queue.cc
    rtc_base/buffer_queue.h
    rtc_base/byte_buffer.cc
    rtc_base/byte_buffer.h
    rtc_base/byte_order.h
    rtc_base/copy_on_write_buffer.cc
    rtc_base/copy_on_write_buffer.h
    rtc_base/event.cc
    rtc_base/event.h
    rtc_base/event_tracer.cc
    rtc_base/event_tracer.h
    rtc_base/hash.h
    rtc_base/location.cc
    rtc_base/location.h
    rtc_base/numerics/histogram_percentile_counter.cc
    rtc_base/numerics/histogram_percentile_counter.h
    rtc_base/numerics/mod_ops.h
    rtc_base/numerics/moving_max_counter.h
    rtc_base/numerics/sample_counter.cc
    rtc_base/numerics/sample_counter.h
    rtc_base/one_time_event.h
    rtc_base/race_checker.cc
    rtc_base/race_checker.h
    rtc_base/random.cc
    rtc_base/random.h
    rtc_base/rate_statistics.cc
    rtc_base/rate_statistics.h
    rtc_base/rate_tracker.cc
    rtc_base/rate_tracker.h
    rtc_base/swap_queue.h
    rtc_base/timestamp_aligner.cc
    rtc_base/timestamp_aligner.h
    rtc_base/trace_event.h
    rtc_base/zero_memory.cc
    rtc_base/zero_memory.h
    rtc_base/string_encode.cc
    rtc_base/string_encode.h
    rtc_base/string_to_number.cc
    rtc_base/string_to_number.h
    rtc_base/string_utils.cc
    rtc_base/string_utils.h
    rtc_base/weak_ptr.cc
    rtc_base/weak_ptr.h
    rtc_base/win32.cc
    rtc_base/win32.h
    rtc_base/win32_window.cc
    rtc_base/win32_window.h
    rtc_base/containers/as_const.h
    rtc_base/containers/flat_map.h
    rtc_base/containers/flat_set.h
    rtc_base/containers/flat_tree.cc
    rtc_base/containers/flat_tree.h
    rtc_base/containers/identity.h
    rtc_base/containers/invoke.h
    rtc_base/containers/move_only_int.h
    rtc_base/containers/not_fn.h
    rtc_base/containers/void_t.h
    rtc_base/win/scoped_com_initializer.cc
    rtc_base/win/scoped_com_initializer.h
    rtc_base/win/windows_version.cc
    rtc_base/win/windows_version.h
    rtc_base/win/create_direct3d_device.cc
    rtc_base/win/create_direct3d_device.h
    rtc_base/strings/string_builder.cc
    rtc_base/strings/string_builder.h
    rtc_base/strings/string_format.cc
    rtc_base/strings/string_format.h
    # rtc_base/experiments/experimental_screenshare_settings.cc
    # rtc_base/experiments/experimental_screenshare_settings.h
    rtc_base/experiments/encoder_info_settings.cc
    rtc_base/experiments/encoder_info_settings.h
    rtc_base/experiments/alr_experiment.cc
    rtc_base/experiments/balanced_degradation_settings.cc
    rtc_base/experiments/cpu_speed_experiment.cc
    rtc_base/experiments/field_trial_list.cc
    rtc_base/experiments/field_trial_parser.cc
    rtc_base/experiments/field_trial_units.cc

=== debian/changelog ===
libtgowt (0~git20211207.d5c3d43+dfsg-2~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 20 Dec 2021 15:18:06 -0800

libtgowt (0~git20211207.d5c3d43+dfsg-2) unstable; urgency=medium

  * New Better-denormal-check.patch to fix FTBFS on armel.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 12 Dec 2021 16:24:53 +0300

libtgowt (0~git20211207.d5c3d43+dfsg-1) unstable; urgency=medium

  [ Nicholas Guriev ]
  * Update to the latest upstream commit.
  * Build against system abseil. Mark this library as transitive dependency.
  * Revert "Define NO_MAIN_THREAD_WRAPPING macro through d/rules".
    - Now upstream CMake scripts define this macro.

  [ Gianfranco Costamagna ]
  * Build depend on unversioned libjpeg-dev to fix an installation failure.
    (Closes: #992865)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 12 Dec 2021 00:29:57 +0300

=== debian/control ===
Source: libtgowt
Priority: optional
Section: libs
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch: cmake (>= 3.16.0),
                    libabsl-dev,
                    libasound2-dev,
                    libavcodec-dev,
                    libavformat-dev,
                    libavutil-dev,
                    libglib2.0-dev,
                    libjpeg-dev,
                    libopus-dev,
                    libpipewire-0.3-dev | libpipewire-0.2-dev,
                    libprotobuf-dev,
                    libpulse-dev,
                    libssl-dev,
                    libswresample-dev,
                    libswscale-dev,
                    libxcomposite-dev,
                    libxdamage-dev,
                    libxext-dev,
                    libxfixes-dev,
                    libxrandr-dev,
                    libxrender-dev,
                    libxtst-dev,
                    protobuf-compiler,
                    python3:any,
                    yasm [any-amd64 any-i386 x32]
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://github.com/desktop-app/tg_owt
Vcs-Git: https://salsa.debian.org/debian/libtgowt.git
Vcs-Browser: https://salsa.debian.org/debian/libtgowt

Package: libtgowt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libabsl-dev, ${misc:Depends}, ${static:Depends}
Description: telegram related WebRTC fork
 This supporting package contains a reduced fork of WebRTC source code. It is
 primarily needed for build support of video calls in Telegram Desktop. WebRTC
 project, in general, provides applications real-time capabilities that work on
 top of an open standard.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/dpkg/default.mk

%:
	dh $@

TEMP_DIR = debian/tmp
INSTALL_DIR = debian/libtgowt-dev
INCLUDE_DIR = $(INSTALL_DIR)/usr/include/tg_owt
FILES_EXCLUDED = src/third_party/abseil-cpp src/third_party/pipewire src/third_party/rnnoise src/third_party/yasm

# Do not build the library as shared. That's not supported by upstream and too
# difficult to guarantee binary compatibility of C++ code.
EXTRA_CMAKE_VARIABLES += BUILD_SHARED_LIBS=OFF TG_OWT_USE_PROTOBUF=ON TG_OWT_DLOPEN_PIPEWIRE=ON

ifeq ($(DEB_HOST_ARCH_CPU),i386)
# Do not force SSE2 extension. Rely on checking via cpuid.
EXTRA_CMAKE_VARIABLES += TG_OWT_ARCH_X86_FORCE_SSE=OFF
endif

ifeq ($(DEB_HOST_ARCH),armhf)
# WebRTC provides no runtime NEON checking, forbid unconditionally usage.
EXTRA_CMAKE_VARIABLES += TG_OWT_ARCH_ARMV7_USE_NEON=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

execute_after_dh_auto_install:
# Cut non UTF-8 bytes off to silence national-encoding Lintian warning. Regex taken from https://stackoverflow.com/a/1401716/5000805
	find $(INCLUDE_DIR) -type f -print0 | xargs -0 perl -pi -e 's/((?:[\x00-\x7F]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}){1,100})|./$$1/g'
# Comment PACKAGE and related macros to fix package-name-defined-in-config-h Lintian warning.
	find $(INCLUDE_DIR) -name config.h -print0 | xargs -0 sed -i '/\<PACKAGE\(_\|\>\)/s!^\s*#\s*define\s\+!//def!'
# Skip empty directories to fix package-contains-empty-directory Lintian info diagnostic.
	find $(INCLUDE_DIR) -empty -type d -delete

# Collect all required packages for linking against the static library.
execute_before_dh_gencontrol:
	find $(INSTALL_DIR)/usr -name '*.cmake' | xargs grep -h -o '[^";]*\.so\>' | sort -u | xargs dpkg -S > debian/libtgowt-dev.deps
	echo static:Depends=$$(awk -F: '{print $$1 ","}' debian/libtgowt-dev.deps) >> debian/libtgowt-dev.substvars
ifeq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
	column -t debian/libtgowt-dev.deps
endif

execute_after_dh_clean:
	$(RM) debian/libtgowt-dev.deps

# Download and repack original source code by hand because of uscan(1) does not
# support yet recursive cloning Git repositories. The next script additionally
# invokes tar(1) with options to generate reproducible tarball. You can install
# archiver tool from PyPI: https://pypi.org/project/git-archive-all/
get-orig-source:
	@trap 'rm -rf $(TEMP_DIR)' EXIT ; set -e -u -x
	git clone --depth=1 https://github.com/desktop-app/tg_owt $(TEMP_DIR)/libtgowt.git
	git -C $(TEMP_DIR)/libtgowt.git submodule update --init --depth=1
	VERSION=`git -C $(TEMP_DIR)/libtgowt.git log -1 --format=0~git%cd.%h --date=format:%Y%m%d`
	MODIFIED=`git -C $(TEMP_DIR)/libtgowt.git log -1 --format=@%ct`
	git-archive-all -C $(TEMP_DIR)/libtgowt.git --prefix=libtgowt-$$VERSION/ $(TEMP_DIR)/libtgowt.tar
	tar -xf $(TEMP_DIR)/libtgowt.tar -C $(TEMP_DIR)
	rm -r $(addprefix $(TEMP_DIR)/libtgowt-$$VERSION/,$(FILES_EXCLUDED))
	tar --sort=name --owner=root:0 --group=root:0 --mtime=$$MODIFIED -caf ../libtgowt_$$VERSION+dfsg.orig.tar.xz -C $(TEMP_DIR) libtgowt-$$VERSION

ifeq ($(MAKECMDGOALS),get-orig-source)
.ONESHELL:
endif

## libtgowt 0~git20220202.d618d0b%2Bdfsg

=== src/third_party/libyuv/CMakeLists.txt ===
# CMakeLists for libyuv
# Originally created for "roxlu build system" to compile libyuv on windows
# Run with -DTEST=ON to build unit tests

PROJECT ( YUV C CXX )	# "C" is required even for C++ projects
CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )
OPTION( TEST "Built unit tests" OFF )

SET ( ly_base_dir	${PROJECT_SOURCE_DIR} )
SET ( ly_src_dir	${ly_base_dir}/source )
SET ( ly_inc_dir	${ly_base_dir}/include )
SET ( ly_tst_dir	${ly_base_dir}/unit_test )
SET ( ly_lib_name	yuv )
SET ( ly_lib_static	${ly_lib_name} )
SET ( ly_lib_shared	${ly_lib_name}_shared )

FILE ( GLOB_RECURSE	ly_source_files ${ly_src_dir}/*.cc )
LIST ( SORT			ly_source_files )

FILE ( GLOB_RECURSE	ly_unittest_sources ${ly_tst_dir}/*.cc )
LIST ( SORT			ly_unittest_sources )

INCLUDE_DIRECTORIES( BEFORE ${ly_inc_dir} )

# this creates the static library (.a)
ADD_LIBRARY				( ${ly_lib_static} STATIC ${ly_source_files} )

# this creates the shared library (.so)
ADD_LIBRARY				( ${ly_lib_shared} SHARED ${ly_source_files} )
SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES OUTPUT_NAME "${ly_lib_name}" )
SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES PREFIX "lib" )

# this creates the conversion tool
ADD_EXECUTABLE			( yuvconvert ${ly_base_dir}/util/yuvconvert.cc )
TARGET_LINK_LIBRARIES	( yuvconvert ${ly_lib_static} )


INCLUDE ( FindJPEG )
if (JPEG_FOUND)
  include_directories( ${JPEG_INCLUDE_DIR} )
  target_link_libraries( yuvconvert ${JPEG_LIBRARY} )
  add_definitions( -DHAVE_JPEG )
endif()

if(TEST)
  find_library(GTEST_LIBRARY gtest)
  if(GTEST_LIBRARY STREQUAL "GTEST_LIBRARY-NOTFOUND")
    set(GTEST_SRC_DIR /usr/src/gtest CACHE STRING "Location of gtest sources")
    if(EXISTS ${GTEST_SRC_DIR}/src/gtest-all.cc)
      message(STATUS "building gtest from sources in ${GTEST_SRC_DIR}")
      set(gtest_sources ${GTEST_SRC_DIR}/src/gtest-all.cc)
      add_library(gtest STATIC ${gtest_sources})
      include_directories(${GTEST_SRC_DIR})
      include_directories(${GTEST_SRC_DIR}/include)
      set(GTEST_LIBRARY gtest)
    else()
      message(FATAL_ERROR "TEST is set but unable to find gtest library")
    endif()
  endif()

  add_executable(libyuv_unittest ${ly_unittest_sources})
  target_link_libraries(libyuv_unittest ${ly_lib_name} ${GTEST_LIBRARY})
  find_library(PTHREAD_LIBRARY pthread)
  if(NOT PTHREAD_LIBRARY STREQUAL "PTHREAD_LIBRARY-NOTFOUND")
    target_link_libraries(libyuv_unittest pthread)
  endif()
  if (JPEG_FOUND)
    target_link_libraries(libyuv_unittest ${JPEG_LIBRARY})
  endif()

  if(NACL AND NACL_LIBC STREQUAL "newlib")
    target_link_libraries(libyuv_unittest glibc-compat)
  endif()

  find_library(GFLAGS_LIBRARY gflags)
  if(NOT GFLAGS_LIBRARY STREQUAL "GFLAGS_LIBRARY-NOTFOUND")
    target_link_libraries(libyuv_unittest gflags)
    add_definitions(-DLIBYUV_USE_GFLAGS)
  endif()
endif()


# install the conversion tool, .so, .a, and all the header files
INSTALL ( PROGRAMS ${CMAKE_BINARY_DIR}/yuvconvert			DESTINATION bin )
INSTALL ( TARGETS ${ly_lib_static}						DESTINATION lib )
INSTALL ( TARGETS ${ly_lib_shared} LIBRARY				DESTINATION lib RUNTIME DESTINATION bin )
INSTALL ( DIRECTORY ${PROJECT_SOURCE_DIR}/include/		DESTINATION include )

# create the .deb and .rpm packages using cpack
INCLUDE ( CM_linux_packages.cmake )

## libtgowt 0~git20220202.d618d0b+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,11 +19,11 @@
     set(not_packaged_build 1)
 endif()
 
-option(BUILD_SHARED_LIBS "Builds shared libraries instead of static." ${TG_OWT_PACKAGED_BUILD})
+option(BUILD_SHARED_LIBS "Builds shared libraries instead of static." OFF)
 option(TG_OWT_USE_PROTOBUF "Use protobuf to generate additional headers. Useful for packaged build." ${BUILD_SHARED_LIBS})
 option(TG_OWT_USE_PIPEWIRE "Use pipewire for desktop capture on non-Apple Unix." ON)
 option(TG_OWT_DLOPEN_PIPEWIRE "dlopen pipewire 0.3 for desktop capture on non-Apple Unix." ${not_packaged_build})
-option(TG_OWT_BUILD_AUDIO_BACKENDS "Build webrtc audio backends." ON)
+option(TG_OWT_BUILD_AUDIO_BACKENDS "Build webrtc audio backends." OFF)
 
 if (NOT UNIX OR APPLE)
     set(TG_OWT_USE_PIPEWIRE OFF)
@@ -31,6 +31,20 @@
 
 if (BUILD_SHARED_LIBS)
     set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+    message(WARNING
+        "tg_owt is a fork of Google's webrtc library and is developed by them as a static library without stable ABI in mind."
+        "The feature of building tg_owt as a shared library is community maintained, it may and will break at any time without guarantee to work again."
+        "Please reconsider your decision. Good luck."
+    )
+endif()
+
+if (TG_OWT_BUILD_AUDIO_BACKENDS)
+    message(WARNING
+        "According to upstream WebRTC developers, audio backends for desktop platforms are only for demo purposes."
+        "It's not recommended to use them. You've been warned."
+        "https://bugs.chromium.org/p/webrtc/issues/detail?id=10537#c2"
+        "https://bugs.chromium.org/p/webrtc/issues/detail?id=10622#c3"
+    )
 endif()
 
 project(tg_owt
@@ -69,7 +83,6 @@
 include(cmake/librnnoise.cmake)
 include(cmake/libsrtp.cmake)
 include(cmake/libusrsctp.cmake)
-include(cmake/libvpx.cmake)
 include(cmake/libyuv.cmake)
 if (APPLE)
     include(cmake/libsdkmacos.cmake)
@@ -91,12 +104,13 @@
         generate_stubs(tg_owt
             ${stubs_loc}/pipewire_stub_header.fragment
             pipewire_stubs
-            ${stubs_loc}/pipewire03.sigs
+            ${stubs_loc}/pipewire.sigs
         )
         target_compile_definitions(tg_owt
         PRIVATE
             WEBRTC_DLOPEN_PIPEWIRE
         )
+
         target_include_directories(tg_owt
         PRIVATE
             ${webrtc_loc}/third_party/pipewire/spa/include
@@ -106,6 +120,20 @@
     else()
         link_pipewire(tg_owt)
     endif()
+
+    link_glib(tg_owt)
+
+    find_package(PkgConfig REQUIRED)
+    pkg_check_modules(GBM REQUIRED gbm)
+    pkg_check_modules(DRM REQUIRED libdrm)
+    pkg_check_modules(EPOXY REQUIRED epoxy)
+
+    target_include_directories(tg_owt
+    PRIVATE
+        ${GBM_INCLUDE_DIRS}
+        ${DRM_INCLUDE_DIRS}
+        ${EPOXY_INCLUDE_DIRS}
+    )
 endif()
 
 set_target_properties(tg_owt PROPERTIES SOVERSION 0 VERSION 0.0.0)
@@ -162,7 +190,6 @@
 
 if (UNIX AND NOT APPLE)
     link_x11(tg_owt)
-    link_glib(tg_owt)
 endif()
 
 function(add_sublibrary postfix)
@@ -323,6 +350,8 @@
     # rtc_base/bind.h
     rtc_base/bit_buffer.cc
     rtc_base/bit_buffer.h
+    rtc_base/bitstream_reader.cc
+    rtc_base/bitstream_reader.h
     rtc_base/buffer.h
     rtc_base/buffer_queue.cc
     rtc_base/buffer_queue.h
@@ -335,7 +364,6 @@
     rtc_base/event.h
     rtc_base/event_tracer.cc
     rtc_base/event_tracer.h
-    rtc_base/hash.h
     rtc_base/location.cc
     rtc_base/location.h
     rtc_base/numerics/histogram_percentile_counter.cc
@@ -377,27 +405,3 @@
     rtc_base/containers/flat_tree.cc
     rtc_base/containers/flat_tree.h
     rtc_base/containers/identity.h
-    rtc_base/containers/invoke.h
-    rtc_base/containers/move_only_int.h
-    rtc_base/containers/not_fn.h
-    rtc_base/containers/void_t.h
-    rtc_base/win/scoped_com_initializer.cc
-    rtc_base/win/scoped_com_initializer.h
-    rtc_base/win/windows_version.cc
-    rtc_base/win/windows_version.h
-    rtc_base/win/create_direct3d_device.cc
-    rtc_base/win/create_direct3d_device.h
-    rtc_base/strings/string_builder.cc
-    rtc_base/strings/string_builder.h
-    rtc_base/strings/string_format.cc
-    rtc_base/strings/string_format.h
-    # rtc_base/experiments/experimental_screenshare_settings.cc
-    # rtc_base/experiments/experimental_screenshare_settings.h
-    rtc_base/experiments/encoder_info_settings.cc
-    rtc_base/experiments/encoder_info_settings.h
-    rtc_base/experiments/alr_experiment.cc
-    rtc_base/experiments/balanced_degradation_settings.cc
-    rtc_base/experiments/cpu_speed_experiment.cc
-    rtc_base/experiments/field_trial_list.cc
-    rtc_base/experiments/field_trial_parser.cc
-    rtc_base/experiments/field_trial_units.cc

=== debian/changelog ===
libtgowt (0~git20220202.d618d0b+dfsg-2~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 10 Feb 2022 15:32:34 -0800

libtgowt (0~git20220202.d618d0b+dfsg-2) unstable; urgency=medium

  * Apply 347400dc upstream commit to fix screen sharing crash in Wayland.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 09 Feb 2022 18:59:44 +0300

libtgowt (0~git20220202.d618d0b+dfsg-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Adjust build scripts.
    - New dependencies: libdrm-dev, libepoxy-dev, libgbm-dev, libvpx-dev.
    - Remove support of PipeWire 0.2, no longer needed for buster-backports.
  * Patches:
    - Rewrite Packaged-PipeWire.patch.
    - New Backport-to-stable-libvpx.patch in main branch for easy backporting.
    - New Prefer-std-bit-over-absl-bits.patch to fix build against non-updated
      Abseil in unstable.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 05 Feb 2022 22:49:15 +0300

=== debian/control ===
--- 
+++ 
@@ -10,15 +10,19 @@
                     libavcodec-dev,
                     libavformat-dev,
                     libavutil-dev,
+                    libdrm-dev,
+                    libepoxy-dev,
+                    libgbm-dev,
                     libglib2.0-dev,
                     libjpeg-dev,
                     libopus-dev,
-                    libpipewire-0.3-dev | libpipewire-0.2-dev,
+                    libpipewire-0.3-dev,
                     libprotobuf-dev,
                     libpulse-dev,
                     libssl-dev,
                     libswresample-dev,
                     libswscale-dev,
+                    libvpx-dev (>= 1.9.0),
                     libxcomposite-dev,
                     libxdamage-dev,
                     libxext-dev,

=== debian/rules ===
--- 
+++ 
@@ -10,9 +10,14 @@
 INCLUDE_DIR = $(INSTALL_DIR)/usr/include/tg_owt
 FILES_EXCLUDED = src/third_party/abseil-cpp src/third_party/pipewire src/third_party/rnnoise src/third_party/yasm
 
-# Do not build the library as shared. That's not supported by upstream and too
-# difficult to guarantee binary compatibility of C++ code.
-EXTRA_CMAKE_VARIABLES += BUILD_SHARED_LIBS=OFF TG_OWT_USE_PROTOBUF=ON TG_OWT_DLOPEN_PIPEWIRE=ON
+# We do build the static library which is advised by upstream. It is too
+# difficult to guarantee binary compatibility of C++ code, and the library has
+# only one dependent, Telegram Desktop client.
+EXTRA_CMAKE_VARIABLES += TG_OWT_USE_PROTOBUF=ON TG_OWT_DLOPEN_PIPEWIRE=ON
+
+# Abseil released on 3 Nov 2021 is required at least. This version is not
+# packaged yet. Define an empty macro for lifetime attribute.
+export DEB_CPPFLAGS_MAINT_APPEND = -DABSL_ATTRIBUTE_LIFETIME_BOUND=
 
 ifeq ($(DEB_HOST_ARCH_CPU),i386)
 # Do not force SSE2 extension. Rely on checking via cpuid.
@@ -43,6 +48,10 @@
 	column -t debian/libtgowt-dev.deps
 endif
 
+# MX don't need no stinkin' dbgsyms
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+
 execute_after_dh_clean:
 	$(RM) debian/libtgowt-dev.deps

## libtgowt 0~git20220508.10d5f4b%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -78,11 +78,11 @@
 include(cmake/target_yasm_sources.cmake)
 include(cmake/external.cmake)
 include(cmake/libabsl.cmake)
+include(cmake/libcrc32c.cmake)
 include(cmake/libopenh264.cmake)
 include(cmake/libpffft.cmake)
 include(cmake/librnnoise.cmake)
 include(cmake/libsrtp.cmake)
-include(cmake/libusrsctp.cmake)
 include(cmake/libyuv.cmake)
 if (APPLE)
     include(cmake/libsdkmacos.cmake)
@@ -100,7 +100,7 @@
 if (TG_OWT_USE_PIPEWIRE)
     if (TG_OWT_DLOPEN_PIPEWIRE)
         include(cmake/generate_stubs.cmake)
-        set(stubs_loc ${webrtc_loc}/modules/desktop_capture/linux)
+        set(stubs_loc ${webrtc_loc}/modules/desktop_capture/linux/wayland)
         generate_stubs(tg_owt
             ${stubs_loc}/pipewire_stub_header.fragment
             pipewire_stubs
@@ -117,22 +117,23 @@
             ${webrtc_loc}/third_party/pipewire/src
             ${webrtc_loc}/third_party/pipewire/build/src
         )
-    else()
-        link_pipewire(tg_owt)
     endif()
 
     link_glib(tg_owt)
+    link_pipewire(tg_owt ${TG_OWT_DLOPEN_PIPEWIRE})
 
     find_package(PkgConfig REQUIRED)
     pkg_check_modules(GBM REQUIRED gbm)
     pkg_check_modules(DRM REQUIRED libdrm)
-    pkg_check_modules(EPOXY REQUIRED epoxy)
-
-    target_include_directories(tg_owt
+    pkg_check_modules(GL REQUIRED gl)
+    pkg_check_modules(EGL REQUIRED egl)
+
+    target_include_directories(tg_owt SYSTEM
     PRIVATE
         ${GBM_INCLUDE_DIRS}
         ${DRM_INCLUDE_DIRS}
-        ${EPOXY_INCLUDE_DIRS}
+        ${GL_INCLUDE_DIRS}
+        ${EGL_INCLUDE_DIRS}
     )
 endif()
 
@@ -140,6 +141,7 @@
 
 target_link_libraries(tg_owt
 PRIVATE
+    tg_owt::libcrc32c
     tg_owt::libpffft
     tg_owt::librnnoise
     tg_owt::libsrtp
@@ -176,7 +178,6 @@
 link_opus(tg_owt)
 link_libabsl(tg_owt)
 link_libopenh264(tg_owt)
-link_libusrsctp(tg_owt)
 link_libvpx(tg_owt)
 
 if (TG_OWT_BUILD_AUDIO_BACKENDS AND (UNIX AND NOT APPLE))
@@ -241,8 +242,6 @@
     rtc_base/crypt_string.h
     rtc_base/checks.cc
     rtc_base/checks.h
-    # rtc_base/critical_section.cc
-    # rtc_base/critical_section.h
     rtc_base/data_rate_limiter.cc
     rtc_base/data_rate_limiter.h
     rtc_base/dscp.h
@@ -256,7 +255,6 @@
     rtc_base/ip_address.h
     rtc_base/logging.cc
     rtc_base/logging.h
-    # rtc_base/keep_ref_until_done.h
     rtc_base/mdns_responder_interface.h
     rtc_base/memory/aligned_malloc.cc
     rtc_base/memory/aligned_malloc.h
@@ -315,8 +313,6 @@
     rtc_base/rtc_certificate_generator.h
     rtc_base/rate_limiter.cc
     rtc_base/rate_limiter.h
-    # rtc_base/signal_thread.cc
-    # rtc_base/signal_thread.h
     rtc_base/sigslot_repeater.h
     rtc_base/socket.cc
     rtc_base/socket.h
@@ -347,7 +343,6 @@
     rtc_base/thread_message.h
     rtc_base/unique_id_generator.cc
     rtc_base/unique_id_generator.h
-    # rtc_base/bind.h
     rtc_base/bit_buffer.cc
     rtc_base/bit_buffer.h
     rtc_base/bitstream_reader.cc
@@ -405,3 +400,6 @@
     rtc_base/containers/flat_tree.cc
     rtc_base/containers/flat_tree.h
     rtc_base/containers/identity.h
+    rtc_base/containers/invoke.h
+    rtc_base/containers/move_only_int.h
+    rtc_base/containers/not_fn.h

## libtgowt 0~git20220508.10d5f4b+dfsg

=== debian/changelog ===
libtgowt (0~git20220508.10d5f4b+dfsg-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 16 Jul 2022 15:44:42 -0700

libtgowt (0~git20220508.10d5f4b+dfsg-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Remove PipeWire from Files-Excluded in debian/copyright.
  * Remove Fix-loading-libdrm-before-first-use.diff taken from upstream repository.
  * Refresh remaining patches resolving conflicts.
  * New build dependencies, libgl-dev and libegl-dev, remove no longer needed
    libepoxy-dev.
  * Update copyright info, new CRC32C library and removed usrsctp.
  * Remove a workaround for PACKAGE_* macros in <config.h> headers.
  * Bump standards version to 4.6.1, no related changes.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 02 Jul 2022 14:46:00 +0300

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,9 @@
                     libavformat-dev,
                     libavutil-dev,
                     libdrm-dev,
-                    libepoxy-dev,
+                    libegl-dev,
                     libgbm-dev,
+                    libgl-dev,
                     libglib2.0-dev,
                     libjpeg-dev,
                     libopus-dev,
@@ -33,7 +34,7 @@
                     protobuf-compiler,
                     python3:any,
                     yasm [any-amd64 any-i386 x32]
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/desktop-app/tg_owt
 Vcs-Git: https://salsa.debian.org/debian/libtgowt.git

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 TEMP_DIR = debian/tmp
 INSTALL_DIR = debian/libtgowt-dev
 INCLUDE_DIR = $(INSTALL_DIR)/usr/include/tg_owt
-FILES_EXCLUDED = src/third_party/abseil-cpp src/third_party/pipewire src/third_party/rnnoise src/third_party/yasm
+FILES_EXCLUDED = src/third_party/abseil-cpp src/third_party/rnnoise src/third_party/yasm
 
 # We do build the static library which is advised by upstream. It is too
 # difficult to guarantee binary compatibility of C++ code, and the library has
@@ -35,8 +35,6 @@
 execute_after_dh_auto_install:
 # Cut non UTF-8 bytes off to silence national-encoding Lintian warning. Regex taken from https://stackoverflow.com/a/1401716/5000805
 	find $(INCLUDE_DIR) -type f -print0 | xargs -0 perl -pi -e 's/((?:[\x00-\x7F]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}){1,100})|./$$1/g'
-# Comment PACKAGE and related macros to fix package-name-defined-in-config-h Lintian warning.
-	find $(INCLUDE_DIR) -name config.h -print0 | xargs -0 sed -i '/\<PACKAGE\(_\|\>\)/s!^\s*#\s*define\s\+!//def!'
 # Skip empty directories to fix package-contains-empty-directory Lintian info diagnostic.
 	find $(INCLUDE_DIR) -empty -type d -delete
 
@@ -48,12 +46,12 @@
 	column -t debian/libtgowt-dev.deps
 endif
 
+execute_after_dh_clean:
+	$(RM) debian/libtgowt-dev.deps
+
 # MX don't need no stinkin' dbgsyms
 override_dh_strip:
 	dh_strip --no-automatic-dbgsym
-
-execute_after_dh_clean:
-	$(RM) debian/libtgowt-dev.deps
 
 # Download and repack original source code by hand because of uscan(1) does not
 # support yet recursive cloning Git repositories. The next script additionally

## libtgowt 0~git20230105.5098730%2Bdfsg

=== debian/control ===
Source: libtgowt
Priority: optional
Section: libs
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch:
 cmake (>= 3.16.0),
 libabsl-dev (>= 0~20220623.0),
 libasound2-dev,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libdrm-dev,
 libegl-dev,
 libgbm-dev,
 libgl-dev,
 libglib2.0-dev,
 libjpeg-dev,
 libopus-dev,
 libpipewire-0.3-dev,
 libprotobuf-dev,
 libpulse-dev,
 libsrtp2-dev,
 libssl-dev,
 libswresample-dev,
 libswscale-dev,
 libvpx-dev (>= 1.9.0),
 libxcomposite-dev,
 libxdamage-dev,
 libxext-dev,
 libxfixes-dev,
 libxrandr-dev,
 libxrender-dev,
 libxtst-dev,
 protobuf-compiler,
 python3:any,
 yasm [any-amd64 any-i386 x32],
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/desktop-app/tg_owt
Vcs-Git: https://salsa.debian.org/debian/libtgowt.git
Vcs-Browser: https://salsa.debian.org/debian/libtgowt

Package: libtgowt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libabsl-dev, ${misc:Depends}, ${static:Depends}
Description: telegram related WebRTC fork
 This supporting package contains a reduced fork of WebRTC source code. It is
 primarily needed for build support of video calls in Telegram Desktop. WebRTC
 project, in general, provides applications real-time capabilities that work on
 top of an open standard.

=== debian/rules ===
--- 
+++ 
@@ -14,15 +14,6 @@
 # difficult to guarantee binary compatibility of C++ code, and the library has
 # only one dependent, Telegram Desktop client.
 EXTRA_CMAKE_VARIABLES += TG_OWT_USE_PROTOBUF=ON TG_OWT_DLOPEN_PIPEWIRE=ON
-
-# Abseil released on 3 Nov 2021 is required at least. This version is not
-# packaged yet. Define an empty macro for lifetime attribute.
-export DEB_CPPFLAGS_MAINT_APPEND = -DABSL_ATTRIBUTE_LIFETIME_BOUND=
-
-ifeq ($(DEB_HOST_ARCH_CPU),i386)
-# Do not force SSE2 extension. Rely on checking via cpuid.
-EXTRA_CMAKE_VARIABLES += TG_OWT_ARCH_X86_FORCE_SSE=OFF
-endif
 
 ifeq ($(DEB_HOST_ARCH),armhf)
 # WebRTC provides no runtime NEON checking, forbid unconditionally usage.
@@ -49,10 +40,6 @@
 execute_after_dh_clean:
 	$(RM) debian/libtgowt-dev.deps
 
-# MX don't need no stinkin' dbgsyms
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-
 # Download and repack original source code by hand because of uscan(1) does not
 # support yet recursive cloning Git repositories. The next script additionally
 # invokes tar(1) with options to generate reproducible tarball. You can install

## libtgowt 0~git20230105.5098730+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,13 @@
 cmake_minimum_required(VERSION 3.16)
 cmake_policy(SET CMP0076 NEW)
 cmake_policy(SET CMP0091 NEW)
+include(CMakeDependentOption)
 
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 
 set(TG_OWT_SPECIAL_TARGET "" CACHE STRING "Use special platform target, like 'macstore' for Mac App Store.")
 
-set(CMAKE_OSX_DEPLOYMENT_TARGET 10.11 CACHE STRING "Minimum OS X deployment version" FORCE)
+set(CMAKE_OSX_DEPLOYMENT_TARGET 10.12 CACHE STRING "Minimum OS X deployment version" FORCE)
 
 if (NOT TG_OWT_SPECIAL_TARGET STREQUAL "")
     set(TG_OWT_PACKAGED_BUILD 0)
@@ -21,13 +22,10 @@
 
 option(BUILD_SHARED_LIBS "Builds shared libraries instead of static." OFF)
 option(TG_OWT_USE_PROTOBUF "Use protobuf to generate additional headers. Useful for packaged build." ${BUILD_SHARED_LIBS})
-option(TG_OWT_USE_PIPEWIRE "Use pipewire for desktop capture on non-Apple Unix." ON)
-option(TG_OWT_DLOPEN_PIPEWIRE "dlopen pipewire 0.3 for desktop capture on non-Apple Unix." ${not_packaged_build})
+cmake_dependent_option(TG_OWT_USE_X11 "Use X11 for desktop capture." ON "UNIX; NOT APPLE" OFF)
+cmake_dependent_option(TG_OWT_USE_PIPEWIRE "Use pipewire for desktop capture." ON "UNIX; NOT APPLE" OFF)
+cmake_dependent_option(TG_OWT_DLOPEN_PIPEWIRE "dlopen pipewire for desktop capture." ${not_packaged_build} TG_OWT_USE_PIPEWIRE OFF)
 option(TG_OWT_BUILD_AUDIO_BACKENDS "Build webrtc audio backends." OFF)
-
-if (NOT UNIX OR APPLE)
-    set(TG_OWT_USE_PIPEWIRE OFF)
-endif()
 
 if (BUILD_SHARED_LIBS)
     set(CMAKE_POSITION_INDEPENDENT_CODE ON)
@@ -141,7 +139,6 @@
 
 target_link_libraries(tg_owt
 PRIVATE
-    tg_owt::libcrc32c
     tg_owt::libpffft
     tg_owt::librnnoise
     tg_owt::libsrtp
@@ -179,6 +176,7 @@
 link_libabsl(tg_owt)
 link_libopenh264(tg_owt)
 link_libvpx(tg_owt)
+link_crc32c(tg_owt)
 
 if (TG_OWT_BUILD_AUDIO_BACKENDS AND (UNIX AND NOT APPLE))
     link_libalsa(tg_owt)
@@ -189,7 +187,7 @@
 include(cmake/libwebrtcbuild.cmake)
 target_link_libraries(tg_owt PUBLIC tg_owt::libwebrtcbuild)
 
-if (UNIX AND NOT APPLE)
+if (TG_OWT_USE_X11)
     link_x11(tg_owt)
 endif()
 
@@ -219,9 +217,6 @@
 PRIVATE
     rtc_base/deprecated/recursive_critical_section.cc
     rtc_base/deprecated/recursive_critical_section.h
-    rtc_base/async_invoker.cc
-    rtc_base/async_invoker.h
-    rtc_base/async_invoker_inl.h
     rtc_base/async_packet_socket.cc
     rtc_base/async_packet_socket.h
     rtc_base/async_resolver_interface.cc
@@ -260,10 +255,9 @@
     rtc_base/memory/aligned_malloc.h
     rtc_base/memory/fifo_buffer.cc
     rtc_base/memory/fifo_buffer.h
+    rtc_base/memory/always_valid_pointer.h
     rtc_base/message_digest.cc
     rtc_base/message_digest.h
-    rtc_base/message_handler.cc
-    rtc_base/message_handler.h
     rtc_base/net_helper.cc
     rtc_base/net_helper.h
     rtc_base/net_helpers.cc
@@ -313,7 +307,6 @@
     rtc_base/rtc_certificate_generator.h
     rtc_base/rate_limiter.cc
     rtc_base/rate_limiter.h
-    rtc_base/sigslot_repeater.h
     rtc_base/socket.cc
     rtc_base/socket.h
     rtc_base/socket_adapters.cc
@@ -340,7 +333,6 @@
     rtc_base/time_utils.h
     rtc_base/thread.cc
     rtc_base/thread.h
-    rtc_base/thread_message.h
     rtc_base/unique_id_generator.cc
     rtc_base/unique_id_generator.h
     rtc_base/bit_buffer.cc
@@ -359,12 +351,11 @@
     rtc_base/event.h
     rtc_base/event_tracer.cc
     rtc_base/event_tracer.h
-    rtc_base/location.cc
-    rtc_base/location.h
     rtc_base/numerics/histogram_percentile_counter.cc
     rtc_base/numerics/histogram_percentile_counter.h
     rtc_base/numerics/mod_ops.h
     rtc_base/numerics/moving_max_counter.h
+    rtc_base/numerics/moving_percentile_filter.h
     rtc_base/numerics/sample_counter.cc
     rtc_base/numerics/sample_counter.h
     rtc_base/one_time_event.h
@@ -394,7 +385,6 @@
     rtc_base/win32.h
     rtc_base/win32_window.cc
     rtc_base/win32_window.h
-    rtc_base/containers/as_const.h
     rtc_base/containers/flat_map.h
     rtc_base/containers/flat_set.h
     rtc_base/containers/flat_tree.cc
@@ -402,4 +392,7 @@
     rtc_base/containers/identity.h
     rtc_base/containers/invoke.h
     rtc_base/containers/move_only_int.h
-    rtc_base/containers/not_fn.h
+    rtc_base/win/scoped_com_initializer.cc
+    rtc_base/win/scoped_com_initializer.h
+    rtc_base/win/windows_version.cc
+    rtc_base/win/windows_version.h

=== cmake/protobuf/CMakeLists.txt ===
find_package(Protobuf REQUIRED)

add_library(proto OBJECT)
init_target(proto)
add_library(tg_owt::proto ALIAS proto)

target_compile_definitions(proto
PRIVATE
    HAVE_CONFIG_H
)

set(proto_files
    ${webrtc_loc}/logging/rtc_event_log/rtc_event_log.proto
    ${webrtc_loc}/logging/rtc_event_log/rtc_event_log2.proto
)

protobuf_generate_cpp(proto_sources proto_headers ${proto_files})
set_source_files_properties(${proto_sources} ${proto_headers} PROPERTIES GENERATED TRUE)

target_sources(proto
PRIVATE
    ${proto_headers}
    ${proto_sources}
)

# CMAKE_CURRENT_BINARY_DIR is always used by protobuf_generate_cpp
# to place the generated files. It cannot be changed or overridden.
# We have to push it to the main project because the generated sources
# and headers will be used as include files.
target_include_directories(proto
INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
PRIVATE
    ${Protobuf_INCLUDE_DIRS}
)

target_link_libraries(proto
PRIVATE
    ${Protobuf_LIBRARIES}
)

=== src/third_party/libyuv/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Run with -DTEST=ON to build unit tests
 
 PROJECT ( YUV C CXX )	# "C" is required even for C++ projects
-CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )
+CMAKE_MINIMUM_REQUIRED( VERSION 2.8.12 )
 OPTION( TEST "Built unit tests" OFF )
 
 SET ( ly_base_dir	${PROJECT_SOURCE_DIR} )
@@ -22,6 +22,10 @@
 
 INCLUDE_DIRECTORIES( BEFORE ${ly_inc_dir} )
 
+if(MSVC)
+  ADD_DEFINITIONS ( -D_CRT_SECURE_NO_WARNINGS )
+endif()
+
 # this creates the static library (.a)
 ADD_LIBRARY				( ${ly_lib_static} STATIC ${ly_source_files} )
 
@@ -29,6 +33,9 @@
 ADD_LIBRARY				( ${ly_lib_shared} SHARED ${ly_source_files} )
 SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES OUTPUT_NAME "${ly_lib_name}" )
 SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES PREFIX "lib" )
+if(WIN32)
+  SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES IMPORT_PREFIX "lib" )
+endif()
 
 # this creates the conversion tool
 ADD_EXECUTABLE			( yuvconvert ${ly_base_dir}/util/yuvconvert.cc )
@@ -71,12 +78,6 @@
   if(NACL AND NACL_LIBC STREQUAL "newlib")
     target_link_libraries(libyuv_unittest glibc-compat)
   endif()
-
-  find_library(GFLAGS_LIBRARY gflags)
-  if(NOT GFLAGS_LIBRARY STREQUAL "GFLAGS_LIBRARY-NOTFOUND")
-    target_link_libraries(libyuv_unittest gflags)
-    add_definitions(-DLIBYUV_USE_GFLAGS)
-  endif()
 endif()

=== debian/changelog ===
libtgowt (0~git20230105.5098730+dfsg-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Revert "Increase minimal abseil version to 20220623.0".
  * New Backport-to-stable-Abseil.patch.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 23 Jan 2023 11:13:45 +0300

libtgowt (0~git20230105.5098730+dfsg-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Increase minimal abseil version to 20220623.0.
  * Remove patches:
    - Conflicting Avoid-SSE2-on-i386.patch until bug#995194 is fixed.
    - Prefer-std-bit-over-absl-bits.patch since backporting to bullseye
      requires more changes.
    - Ignore-sanitize-attr.patch because upstream already seems compatible
      with GCC.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 10 Jan 2023 23:20:23 +0300

libtgowt (0~git20220508.10d5f4b+dfsg-1~bpo11+1) bullseye-backports; urgency=medium

  * No-change rebuild for bullseye-backports.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 27 Oct 2022 23:27:34 +0300

libtgowt (0~git20220202.d618d0b+dfsg-2~bpo11+1) bullseye-backports; urgency=medium

  * No-change rebuild for bullseye-backports.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 14 Feb 2022 22:37:26 +0300

libtgowt (0~git20211207.d5c3d43+dfsg-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Andreas Tille <tille@debian.org>  Wed, 19 Jan 2022 20:55:36 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13)
 Build-Depends-Arch:
  cmake (>= 3.16.0),
- libabsl-dev (>= 0~20220623.0),
+ libabsl-dev,
  libasound2-dev,
  libavcodec-dev,
  libavformat-dev,
@@ -20,7 +20,6 @@
  libpipewire-0.3-dev,
  libprotobuf-dev,
  libpulse-dev,
- libsrtp2-dev,
  libssl-dev,
  libswresample-dev,
  libswscale-dev,

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,10 @@
 # difficult to guarantee binary compatibility of C++ code, and the library has
 # only one dependent, Telegram Desktop client.
 EXTRA_CMAKE_VARIABLES += TG_OWT_USE_PROTOBUF=ON TG_OWT_DLOPEN_PIPEWIRE=ON
+
+# Abseil released on 3 Nov 2021 is required at least. This version is not
+# packaged yet. Define an empty macro for lifetime attribute.
+export DEB_CPPFLAGS_MAINT_APPEND = -DABSL_ATTRIBUTE_LIFETIME_BOUND=
 
 ifeq ($(DEB_HOST_ARCH),armhf)
 # WebRTC provides no runtime NEON checking, forbid unconditionally usage.
